=== Source/ExtDVObjs/CMakeLists.txt ===
set_property(DIRECTORY . PROPERTY FOLDER "ExtDVObjs")

include(PurCCommon)

add_subdirectory(fs)
add_subdirectory(math)
