=== Source/Tools/CMakeLists.txt ===
if (HAVE_GLIB AND HAVE_NCURSES)
#    add_subdirectory(udom-editor)
endif ()

add_subdirectory(purc)
