=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

override_dh_auto_configure:
	cmake -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=/usr -DPORT=Linux .

#override_dh_installdocs:
# Do not install a copyright file
# no /usr/share/docs/* needed!
#dh_installdocs --exclude=debian/copyright
# Do not install changelogs for space conservation
#override_dh_installchangelogs:
